# cta.py
#
# Read the ctabus.csv using columns
import csv
from datetime import date
import numpy

def read_data(filename):
    # Four columns of data
    routes = []
    dates = []
    daytypes = []
    rides = []
    with open(filename) as f:
        rows = csv.reader(f)
        headers = next(rows)   # Skip the headers on first line
        for row in rows:
            routes.append(cached(row[0]))
            parts = row[1].split('/')
            dates.append(cached(date(int(parts[2]),
                                     int(parts[0]),
                                     int(parts[1]))))
            daytypes.append(row[2])
            rides.append(int(row[3]))
    # Problem.  How to return back?
    return {
        'routes': numpy.array(routes),
        'dates': numpy.array(dates),
        'daytypes': numpy.array(daytypes),
        'rides': numpy.array(rides)
        }

# Make a string cache of common strings (in the data)
_cache = { }

def cached(s):
    if s in _cache:
        return _cache[s]
    else:
        _cache[s] = s
        return s

# 58 Mbytes storing as columns  (previous best 104MB)
records = read_data('ctabus.csv')
import os
print(os.getpid())

        
